<?



$restrict = "";
$maingui =& GUIFactory::setMainGUI( "main" );
$maingui->includeJS("jquery-1.6.1.min");
$maingui->excludeJS("jquery");
$maingui->includeJS("jquery.gtxpercent");

load_menu( 301, $T_MAINTENANCE );




$sql = "SELECT node.id id, node.folder_id folder_id, folder.name name FROM node, folder WHERE node.folder_id = folder.id";
$rs = query($sql);

$node_infos = array();


if ($rs["arr"]) {
 while (list($key,$val) = each($rs["arr"])) {
 if (perm($USER_ID,$T_DOMAIN,$val["folder_id"],0)) {
 $node_infos[$val["id"]] = $val;
 }
 }
}


if (sizeof($node_infos) == 0) {
 $restrict = "1 = 2";
} else {
 $restrict = "node.id IN (".implode(",", sqlf_value_array(array_keys($node_infos))).")";
}

function executeTool( &$form, $param ) {
 global $restrict, $FEATURE, $node_infos, $USER_ID, $T_MAINTENANCE;

 if (!perm($USER_ID,$T_MAINTENANCE,"",2)) {
 return;
 }
 
 $tools =& $form->resolveComponent("main.tools");
 $nodeComponent =& $form->resolveComponent("main.node");
 $status =& $form->resolveComponent("status");
 $tool = $tools->getSingleSelection();
 $node = $nodeComponent->getSingleSelection();

 $crComponent =& $form->resolveComponent("main.contentrepository");
 $contentrepository = $crComponent->getSingleSelection();

 
 if ($contentrepository != -1 && $contentrepository != "all") {
 $sql = "SELECT id FROM node WHERE contentrepository_id != ".sqlf_tl_num($contentrepository);
 $rs = query($sql);
 while (list($key, $val) = each($rs["arr"])) {
 unset($node_infos[$val["id"]]);
 }
 }

 $rangeSelectComponent =& $form->resolveComponent("main.rangeselect");
 $range = $rangeSelectComponent->getSingleSelection();
 $rangeStartComponent =& $form->resolveComponent("main.rangeStart");
 $rangeEndComponent =& $form->resolveComponent("main.rangeEnd");
 $rangeStart = $rangeStartComponent->getTimestamp();
 $rangeEnd = $rangeEndComponent->getTimestamp();

 if( $range == 'creation' ) $range = 'cdate';
 else $range = NULL;

 $where = "";
 if ($FEATURE["javaparser"]) {
 $modified = array();
 if ($node == -1 || $node == "all") {
 
 if (count($node_infos) == 0) {
 $status->setText( i18n( "No Node met your restrictions" ) );
 return;
 }
 $modified[] = implode("|", array_keys($node_infos));
 } else {
 if (!$node_infos[$node]) {
 $status->setText( i18n( "No Node met your restrictions" ) );
 return;
 }
 $modified[] = $node;
 }
 if ($range) {
 $modified[] = $range;
 $modified[] = $rangeStart;
 $modified[] = $rangeEnd;
 }

 }
 if ($tool == "republish_all") {
 if ($modified[0] != "") {
 triggerEvent(T_PAGE, "0", EVENT_MAINTENANCE_PUBLISH, new EventObject(null, $modified));
 triggerEvent(CT_FILE, "0", EVENT_MAINTENANCE_PUBLISH, new EventObject(null, $modified));
 triggerEvent(T_FOLDER, "0", EVENT_MAINTENANCE_PUBLISH, new EventObject(null, $modified));
 }
 $status->setText( i18n( "All objects will be republished" )."<br/>".i18n("maintenance_description") );
 logcmd( W_MAINTENANCE, T_PAGE, 0, 0, "Republishing pages - {" . $rs['num'] . "}" );
 } else if( $tool == "republish_pages" ) {
 
 if ($FEATURE["javaparser"]) {
 if ($modified[0] != "") {
 triggerEvent(T_PAGE, "0", EVENT_MAINTENANCE_PUBLISH, new EventObject(null, $modified));
 }
 } else {
 $sql = "UPDATE page, folder, node SET status = 1, delay_publish = 0 WHERE status = 2 AND page.folder_id = folder.id AND folder.node_id = node.id AND node.disable_publish = 0 AND $restrict $where";
 if( $node != "all" ) {
 $sql = "UPDATE page, folder, node SET page.status = 1, delay_publish = 0 WHERE page.status = 2 AND page.folder_id = folder.id AND folder.node_id = node.id AND node.disable_publish = 0 AND folder.node_id = '".sqlf_escaped($node)."'";
 }
 if( $range ) $sql .= " AND ".sqlf_field("page.$range")." >= ".sqlf_value($rangeStart)." AND ".sqlf_field("page.$range")." <= ".sqlf_value($rangeEnd)." ";
 $rs = query($sql);
 $sql = "DELETE FROM objtranslatecache";
 query($sql);
 }
 $status->setText( i18n( "All pages have been reset" )."<br/>".i18n("maintenance_description") );
 logcmd( W_MAINTENANCE, T_PAGE, 0, 0, "Republishing pages - {" . $rs['num'] . "}" );
 } else if( $tool == "republish_files" ) {
 
 if ($FEATURE["javaparser"]) {
 if ($modified[0] != "") {
 triggerEvent(CT_FILE, "0", EVENT_MAINTENANCE_PUBLISH, new EventObject(null, $modified));
 }
 } else {
 if( $node != "all" ) {
 $where = "INNER JOIN folder ON contentfile.folder_id = folder.id WHERE folder.node_id = '" . sqlf_escaped($node) . "'";
 if( $range ) $where .= " AND ";
 } else if( $range ) {
 $where .= "LEFT JOIN folder on contentfile.folder_id = folder.id LEFT JOIN node on folder.node_id = node.id WHERE $restrict AND ";
 } else {
 $where .= "LEFT JOIN folder on contentfile.folder_id = folder.id LEFT JOIN node on folder.node_id = node.id WHERE $restrict";
 }
 
 $sql = "INSERT INTO logcmd (user_id, cmd_desc_id, o_type, o_id, timestamp) SELECT 1, 339, 10008, contentfile.id, unix_timestamp() from contentfile $where";
 if( $range ) $sql .= " ".sqlf_field("contentfile.$range")." >= ".sqlf_value($rangeStart)." AND ".sqlf_field("contentfile.$range")." <= ".sqlf_value($rangeEnd)." ";
 query( $sql );
 $sql = "INSERT INTO logcmd (user_id, cmd_desc_id, o_type, o_id, timestamp) SELECT 1, 550, 10008, contentfile.id, unix_timestamp() from contentfile $where";
 if( $range ) $sql .= " ".sqlf_field("contentfile.$range")." >= ".sqlf_value($rangeStart)." AND ".sqlf_field("contentfile.$range")." <= ".sqlf_value($rangeEnd)." ";
 query( $sql );
 }
 $status->setText( i18n( "All Files will be republished" )."<br/>".i18n("maintenance_description") );
 } else if( $tool == "republish_folders" ) {
 
 if ($FEATURE["javaparser"]) {
 if ($modified[0] != "") {
 triggerEvent(T_FOLDER, "0", EVENT_MAINTENANCE_PUBLISH, new EventObject(null, $modified));
 }
 } else {
 if( $node != "all" ) {
 $where = "WHERE folder.node_id = '" . sqlf_escaped($node) . "'";
 if( $range ) $where .= " AND ";
 } else if( $range ) {
 $where .= "LEFT JOIN node ON folder.node_id = node.id WHERE $restict AND  ";
 } else {
 $where .= "LEFT JOIN node ON folder.node_id = node.id WHERE $restrict";
 }
 
 $sql = "INSERT INTO logcmd (user_id, cmd_desc_id, o_type, o_id, timestamp) SELECT 1, 339, 10002, folder.id, unix_timestamp() from folder $where";
 if( $range ) $sql .= " ".sqlf_field("folder.$range")." >= ".sqlf_value($rangeStart)." AND ".sqlf_field("folder.$range")." <= ".sqlf_value($rangeEnd)." ";
 query( $sql );
 }

 $status->setText( i18n( "All Folders will be republished" )."<br/>".i18n("maintenance_description") );

 } else if ($tool == "stop_publishing") {
 node_class("codeparser");
 node_class("nodefactory");
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->stopPublish();
 } else if ($tool == "delay_pages") {
 if ($FEATURE["javaparser"]) {
 if ($modified[0] != "") {
 triggerEvent(T_PAGE, "0", EVENT_MAINTENANCE_DELAY, new EventObject(null, $modified));
 }
 } else {
 
 $where = "WHERE page.folder_id = folder.id AND folder.node_id = node.id AND status = 1 AND $restrict";
 if ( $node != "all" ) {
 $where .= " AND page.folder_id IN (SELECT folder.id FROM folder, node WHERE folder.node_id = node.id AND node.disable_publish = 0 AND node_id = '".sqlf_escaped($node)."')";
 } else {
 $where .= " AND page.folder_id IN (SELECT folder.id FROM folder, node WHERE folder.node_id = node.id AND node.disable_publish = 0)";
 }
 if ( $range ) {
 $where .= " AND ".sqlf_field("page.$range")." >= ".sqlf_value($rangeStart)." AND ".sqlf_field("page.$range")." <= ".sqlf_value($rangeEnd)." ";
 }
 $sql = "UPDATE page, folder, node SET delay_publish = 1 $where";
 query($sql);
 }
 $status->setText( i18n( "Publishing of selected pages has been delayed" )."<br/>".i18n("maintenance_description"));
 } else if ($tool == "republish_delayed") {
 if ($FEATURE["javaparser"]) {
 if ($modified[0] != "") {
 triggerEvent(T_PAGE, "0", EVENT_MAINTENANCE_REPUBLISH, new EventObject(null, $modified));
 }
 } else {
 
 $where = "WHERE page.folder_id = folder.id AND folder.node_id = node.id AND page.delay_publish = 1 AND $restrict";
 if ( $node != "all" ) {
 $where .= " AND page.folder_id IN (SELECT folder.id FROM folder, node WHERE folder.node_id = node.id AND node.disable_publish = 0 AND node_id = '".sqlf_escaped($node)."')";
 } else {
 $where .= " AND page.folder_id IN (SELECT folder.id FROM folder, node WHERE folder.node_id = node.id AND node.disable_publish = 0)";
 }
 if ( $range ) {
 $where .= " AND ".sqlf_field($range)." >= ".sqlf_value($rangeStart)." AND ".sqlf_field($range)." <= ".sqlf_value($rangeEnd)." ";
 }
 $sql = "UPDATE page, folder, node SET page.delay_publish = 0 $where";
 query($sql);
 }

 $status->setText( i18n( "Delayed pages have been republished" )."<br/>".i18n("maintenance_description"));
 } else if ($tool == "mark_pages_published") {
 if ($FEATURE["javaparser"]) {
 if ($modified[0] != "") {
 triggerEvent(T_PAGE, "0", EVENT_MAINTENANCE_MARKPUBLISHED, new EventObject(null, $modified));
 }
 } else {
 
 $where = "WHERE page.folder_id = folder.id AND folder.node_id = node.id AND $restrict AND page.id = publish.page_id AND publish.active = 1 AND status = 1";
 
 if ( $node != "all" ) {
 $where .= " AND page.folder_id IN (SELECT folder.id FROM folder, node WHERE folder.node_id = node.id AND node.disable_publish = 0 AND node_id = '".sqlf_escaped($node)."')";
 } else {
 $where .= " AND page.folder_id IN (SELECT folder.id FROM folder, node WHERE folder.node_id = node.id AND node.disable_publish = 0)";
 }
 if ( $range ) {
 $where .= " AND ".sqlf_field("page.$range")." >= ".sqlf_value($rangeStart)." AND ".sqlf_field("page.$range")." <= ".sqlf_value($rangeEnd)." ";
 }
 $sql = "UPDATE page, publish, folder, node SET page.delay_publish = 0, page.status = 2 $where";
 query($sql);
 }

 $status->setText( i18n( "Pages have been marked published" )."<br/>".i18n("maintenance_description"));
 }
}

$form = new HtmlForm3("settings");
if ($form->isNew()) {
 node_class("listcomponent");
 node_class("textcomponent");
 node_class("labelcomponent");
 node_class("radiolistcomponent");
 node_class("datecomponent");
 node_class("calendarcomponent");

 $main = new ListComponent();

 $main->setComponent("tools",
 new RadioListComponent( i18n( "Tools" ),
 array( "republish_pages" => i18n("republish pages"),
 "delay_pages" => i18n("delay pages to publish"),
 "republish_delayed" => i18n("republish delayed pages"),
 "mark_pages_published" => i18n("mark pages as published"),
 "republish_files" => i18n("republish files and images"),
 "republish_folders" => i18n("republish all folders"),
 "republish_all" => i18n("republish all"),
 "stop_publishing" => i18n("stop publishing") ) ) );




 $node_options = array();
 $sql = "SELECT node.id AS id, folder.name AS name FROM node INNER JOIN folder ON node.folder_id = folder.id WHERE $restrict ORDER BY folder.name";
 $rs = query( $sql );
 while( list( $key, $value ) = each( $rs["arr"] ) ) {
 $node_options[$value["id"]] = $value["name"];
 }
 $node_options["all"] = '[ ' . i18n("All Nodes") . ' ]';

 $selectNode = new SelectComponent( i18n( "Node" ),
 $node_options);
 $selectNode->setNoneName(i18n("select_item") . '...');
 $main->setComponent("node", $selectNode);

 $cr_options = array();
 $crs = ContentRepository::getSelectOptions(" order by name");
 while(list($key, $val) = each($crs)) {
 $cr_options[$key] = $val;
 }
 $cr_options["all"] = '[ ' . i18n("All ContentRepositories") . ' ]';

 $selectCR = new SelectComponent( i18n("ContentRepository"), $cr_options);
 $selectCR->setNoneName(i18n("select_item") . '...');
 $main->setComponent("contentrepository", $selectCR);

 $rangeSelect = new SelectComponent( i18n( "Limit to date range" ),
 array( 'none' => i18n( "None" ),
 'creation' => i18n( "Creation Date")), 'none' );
 $main->setComponent('rangeselect', $rangeSelect );

 $rangeStart = new DateComponent( i18n( "Range Start" ), false, DCP_DATETIME );
 $main->setComponent("rangestart", $rangeStart);

 $rangeEnd = new DateComponent( i18n( "Range End" ), false, DCP_DATETIME );
 $main->setComponent("rangeend", $rangeEnd);

 $form->setHeader(i18n("Maintenance Tools"));
 $form->addComponent("main",$main);

 $form->addButton("execute", new Button(i18n("Execute Tool")), new SimpleFormAction("executeTool"), true);

 $statusLabel = new LabelComponent(null, "", true );
 $form->addComponent("status", $statusLabel );

 $dirtQueueLabel = new LabelComponent(i18n("dirtqueue_entries"), "", true);
 $form->addComponent("dirtqueue", $dirtQueueLabel);
}


updatePageSums($form);


updateDirtQueueEntries($form);





function updatePageSums(&$form) {
 global $restrict, $help;

 



 
 $sql = "SELECT count(*) c FROM page, folder, node WHERE status = 1 AND page.delay_publish = 0 and page.folder_id = folder.id AND folder.node_id = node.id AND node.disable_publish = 0";
 $rs = query($sql);
 $total_publish = $rs["arr"][0]["c"]; 


 
 
 $sql = "SELECT count(*) c, folder2.name name FROM page, folder, node, folder folder2 WHERE status = 1 AND page.delay_publish = 0 and page.folder_id = folder.id AND folder.node_id = node.id AND node.disable_publish = 0 AND node.folder_id = folder2.id AND $restrict GROUP BY node.id ORDER BY folder2.name";
 $rs = query($sql);
 $help = "<table>";
 $help .= "<tr><td><b>".i18n("Pages To Publish")."</b></td><td align=right>".$total_publish."</td><td></td></tr>";

 $publish_info = getPercentageList($rs["arr"], $total_publish);
 reset($publish_info);
 while (list($key, $val) = each($publish_info)) {
 $help .= "<tr class=\"percent\"><td>".$val["name"]."</td><td align=right>".$val["c"]."</td><td align=right class=\"percentvalue\" title=\"" . $val["perc_round"] . "\">".$val["perc_round"]." %</td></tr>";
 }

 
 $sql = "SELECT count(*) c FROM page, folder, node WHERE status = 1 AND page.delay_publish = 1 and page.folder_id = folder.id AND folder.node_id = node.id AND node.disable_publish = 0";
 $rs = query($sql);
 $total_delayed = $rs["arr"][0]["c"];

 
 
 
 $sql = "SELECT count(*) c, folder2.name name FROM page, folder, node, folder folder2 WHERE status = 1 AND page.delay_publish = 1 and page.folder_id = folder.id AND folder.node_id = node.id AND node.disable_publish = 0 AND node.folder_id = folder2.id AND $restrict GROUP BY node.id ORDER BY folder2.name";
 $rs = query($sql);
 $help .= "<tr><td colspan=3><hr/></td></tr>";
 $help .= "<tr><td><b>".i18n("Pages To Publish Delayed")."</b></td><td align=right>".$total_delayed."</td><td></td></tr>";

 $publish_info = getPercentageList($rs["arr"], $total_delayed);
 reset($publish_info);
 while (list($key, $val) = each($publish_info)) {
 $help .= "<tr class=\"percent\"><td>".$val["name"]."</td><td align=right>".$val["c"]."</td><td align=right class=\"percentvalue\" title=\"".$val["perc_round"]."\">".$val["perc_round"]." %</td></tr>";
 }
 $help .= "</table>";
}

function updateDirtQueueEntries(&$form) {
 $dirtQueueLabel =& $form->resolveComponent("dirtqueue");
 $sql = "select * from dirtqueue where failed = 0 order by timestamp asc";
 $rs = query($sql);

 $dirtQueueEntries = "";
 $lastentry = "unset";
 $counter = 0;
 $isfirst = true;

 while (list($key, $val) = each($rs["arr"])) {
 if (isLoggingEvent($val)) {
 continue;
 }
 $currententry = isMaintenanceEvent($val) ? "maintenance" : (isPublishEvent($val) ? "publish" : "dirt");
 if ($lastentry != $currententry) {
 if ($counter > 0) {
 $dirtQueueEntries .= printDirtQueueLine($counter, $lastentry, $isfirst);
 $isfirst = false;
 }
 $counter = 0;
 $lastentry = $currententry;
 }
 ++$counter;
 }

 if ($counter > 0) {
 $dirtQueueEntries .= printDirtQueueLine($counter, $lastentry, $isfirst); 
 }

 if ($dirtQueueEntries == "") {
 $dirtQueueEntries = i18n("dirtqueue_noentries");
 } else {
 $dirtQueueEntries = "<table>$dirtQueueEntries</table>";
 }

 $dirtQueueLabel->setText($dirtQueueEntries);
}

function printDirtQueueLine($counter, $lastentry, $first) {
 return "<tr><td>".($first ? "<b>" : "")."$counter".($first ? "</b>" : "")."</td><td>".($first ? "<b>" : "").i18n("dirtqueue_$lastentry").($first ? "</b>" : "")."</td></tr>";
}

function isMaintenanceEvent($row) {
 $eventmask = $row["events"];
 return (($eventmask & EVENT_MAINTENANCE_PUBLISH) != 0) ||
 (($eventmask & EVENT_MAINTENANCE_DELAY) != 0) ||
 (($eventmask & EVENT_MAINTENANCE_REPUBLISH) != 0) ||
 (($eventmask & EVENT_MAINTENANCE_MARKPUBLISHED) != 0);
}

function isLoggingEvent($row) {
 $eventmask = $row["events"];
 return (($eventmask & EVENT_LOGGING_START) != 0) ||
 (($eventmask & EVENT_LOGGING_END) != 0);
}

function isPublishEvent($row) {
 return $row["obj_type"] == null && $row["obj_id"] == null && $row["property"] == "publish";
}




function getPercentageList($values, $total_number) {
 $temp_sum = 0;
 $perc_list = array();
 $perc_sum = 0;

 if ($values) {
 while (list($key,$val) = each($values)) {
 $perc = $val["c"] * 100 / $total_number;
 $perc_round = round($perc, 1);
 $perc_sum += $perc_round;
 $temp_arr = array("name" => $val["name"], "perc_round" => $perc_round, "perc" => $perc, "c" => $val["c"]);
 $perc_list[] = $temp_arr; 
 $temp_sum += $val["c"];
 }
 }
 
 if ( $temp_sum < $total_number ) {
 $perc = ($total_number - $temp_sum) * 100 / $total_number;
 $perc_round = round($perc, 1);
 $perc_sum += $perc_round;
 $temp_arr = array("name" => i18n("other"), "perc_round" => $perc_round, "perc" => $perc, "c" => ($total_number - $temp_sum)); 
 $perc_list[] = &$temp_arr;
 }

 if (count($perc_list) == 0) {
 return $perc_list;
 }

 
 while (round($perc_sum, 1) > 100) {
 while ((list ($key, $val) = each($perc_list)) && round($perc_sum, 1) > 100) {
 if ($val["perc_round"] > $val["perc"]) {
 $val["perc_round"] -= 0.1;
 $perc_sum -= 0.1;
 $perc_list[$key] = $val;
 }
 }
 }
 while (round($perc_sum,1) < 100) {
 while ((list ($key, $val) = each($perc_list)) && round($perc_sum,1) < 100) {
 if ($val["perc_round"] < $val["perc"]) {
 $val["perc_round"] += 0.1;
 $perc_sum += 0.1;
 $perc_list[$key] = $val;
 }
 }
 }

 return $perc_list;
}

?>
