<?

function writefs() {

global $LOG, $LOG_FP, $NODEPATH, $FILEPATH, $MODULE, $FEATURE, $DEBUG;
global $RM_PATH, $MV_PATH, $CP_PATH, $LN_PATH, $LS_PATH, $WRITEFS_LASTDUR, $SETTINGS, $IMG_RESIZER_PATH;


$sql = "SELECT id FROM node WHERE publish_fs = 1";
$rs = query($sql);
if ($rs['num'] == 0) return true;

$red_pubpath = "$FILEPATH/$MODULE/publish/pub/";
if ($DEBUG["writefs"]) echo "<pre>--------------------------\n";

$red_nudepath = substr($red_pubpath,0,strlen($red_pubpath)-1);

if (is_dir($red_nudepath."_new")) {
 $outp .= "rm -R $red_nudepath"."_new\n";
 if (node_plattform() == "win32") {
 if ($DEBUG["writefs"]) echo "node_delete (".$red_nudepath."_new)<br>\n";
 node_delete($red_nudepath."_new");
 } else {
 if ($DEBUG["writefs"]) echo node_escapeshellcmd($RM_PATH)." -R ".node_escapeshellpath($red_nudepath."_new")."<br>\n";
 @system(node_escapeshellcmd($RM_PATH)." -R ".node_escapeshellpath($red_nudepath."_new"));
 }
}

$dir = $red_nudepath."_new/";


$outp = "initiating page write...\n";
$t1 = microtime();

log_publish($LOG_FP, $outp);


$eta = round ($WRITEFS_LASTDUR["sum"]);
$sql = "UPDATE nodesetup SET intvalue = ".sqlf_tl_num($eta)." WHERE name = 'publish_eta'";
query ($sql);


$sql = "select count(*) as c from publish, folder, node where publish.active = 1 and publish.folder_id = folder.id and folder.node_id = node.id AND node.publish_fs = 1";
$rs = query($sql);

$number_pages = $rs_tmp["arr"][0]["c"];
$pages_written = 0;
$page_eta = 0; 
$page_time = 0; 

$db_eta = mydb_connect ($SETTINGS); 


$sql = "select node.utf8, publish.page_id, publish.path, publish.filename, publish.pdate, publish.source from publish, folder, node where publish.active = 1 and publish.folder_id = folder.id and folder.node_id = node.id AND node.publish_fs = 1";

$rs = mydb_query($sql);

$writepagestat = LOGOK;


while ($row = mydb_fetch($rs)) {
 set_time_limit( 0 );

 $pt1 = microtime ();
 
 $rel_path = $row["path"];
 $filename = $row["filename"];
 $source = $row["source"];
 if ($FEATURE["UTF8"] && !$row["utf8"]) {
 $source_orig = $source; 
 $source = iconv("UTF-8","CP1252",$source);
 if (is_false($source)) {
 $source = html_encode_utf8($source_orig,true);
 
 }
 }
 $path = $dir.$rel_path;
 $outp = $rel_path.$filename;

 if (!$FEATURE["skip_writefs_filelog"])
 log_publish($LOG_FP, $outp);
 
 checkpath($path,0777,true);
 chdir($path);
 
 $fp = fopen($path.$filename,"w");
 if (!$fp) {
 $outp = "writing $rel_path.$filename FAILED (error !fopen)!\n";
 log_publish($LOG_FP, $outp);
 $outp = LOGFAILED."\n";
 $writepagestat = LOGFAILED;
 
 $fs_err = true;
 } else {
 $outp = "\n";
 
 $writestatus = fwrite($fp,$source);
 $closestatus = fclose($fp);
 touch($path.$filename,$row["pdate"]);
 if( $writestatus === FALSE || ($writestatus == 0 && strlen($source) > 0) ) {
 $outp = LOGFAILED." - write failed (filename: $filename / status: $writestatus)\n";
 $writepagestat = LOGFAILED;
 $fs_err = true;
 
 $out = array(); $returnvalue = 0;
 exec( "echo " . escapeshellarg( $source ) . " 2>&1", $out, $returnvalue );
 $outp .= "output test: " . implode( "\n", $out ) . " ReturnValue: $returnvalue\n";
 } else if( $closestatus === FALSE ) {
 $outp = LOGFAILED." - close failed\n";
 $writepagestat = LOGFAILED;
 $fs_err = true;
 }
 }

 $page_time += calctime ($pt1, microtime (), 5);
 $number_pages--;
 $pages_written++;

 if ($pages_written % 100 == 0)
 {
 $page_eta = ($page_time / $pages_written) * $number_pages;
 $eta = $page_eta + $WRITEFS_LASTDUR[1] + $WRITEFS_LASTDUR[2];
 $eta = round ($eta);

 $sql = "UPDATE nodesetup SET intvalue = ".sqlf_tl_num($eta)." WHERE name = 'publish_eta'";
 query ($sql, $db_eta);
 }
 
 if (!$FEATURE["skip_writefs_filelog"])
 log_publish($LOG_FP,$outp);

}


mydb_close ($db_eta);

$WRITEFS_ACTDUR[0] = round ($page_time, 2);

$t2 = microtime();
$outp = "page write $writepagestat (".calctime($t1,$t2,3).")\n";
log_publish($LOG_FP, $outp);



$eta = round ($WRITEFS_LASTDUR[1] + $WRITEFS_LASTDUR[2]);
$sql = "UPDATE nodesetup SET intvalue = ".sqlf_tl_num($eta)." WHERE name = 'publish_eta'";
query ($sql);



$outp = "initiating file write... ";
log_publish($LOG_FP, $outp);
$sql = "select contentfile.name, contentfile.edate, folder.pub_dir, contentfile.id, folder.node_id, node.host, node.pub_dir AS npub_dir from contentfile, folder, node
where contentfile.folder_id = folder.id AND folder.node_id = node.id AND node.publish_fs = 1";
$rs = query($sql);
$outp = "(".$rs["num"].")\n";
log_publish($LOG_FP, $outp);


$number_files = $rs["num"];
$files_written = 0;
$file_eta = 0; 
$file_time = 0; 



$writefilestat = LOGOK;
if (is_array($rs["arr"]))
while (list($key,$row) = each($rs["arr"])) {
 set_time_limit( 0 );

 $pt1 = microtime ();

 $id = $row["id"];
 $node_id = $row["node_id"];
 $name = $row["name"];
 $pub_dir = $row["pub_dir"];
 $host = $row["host"];
 $nodepub_dir = $row["npub_dir"];
 $path = $dir.$host.$nodepub_dir.$pub_dir;
 $from = "$FILEPATH/$MODULE/dbfiles/$id.bin";
 $outp = $host.$nodepub_dir.$pub_dir.$name;
 if (!$FEATURE["skip_writefs_filelog"])
 log_publish($LOG_FP, $outp);
 checkpath($path,0777,true);












 $tmp = Array();
 if (node_plattform() == "win32") {
 $newname = "$path$name";
 if ($DEBUG["writefs"]) echo "copy($from, $newname)<br>\n";
 copy($from, $newname);
 touch($path.$name,$row["edate"]);
 } else {
 
 
 $newname = "$path$name";
 if ($FEATURE["symlink_files"]) {
 if ($DEBUG["writefs"]) echo node_escapeshellcmd($LS_PATH)." -fs ".node_escapeshellpath($from)." ".node_escapeshellpath($newname)." 2>&1<br>\n";
 exec(node_escapeshellcmd($LN_PATH)." -fs ".node_escapeshellpath($from)." ".node_escapeshellpath($newname)." 2>&1",$tmp,$cpsig);
 } else {
 if ($DEBUG["writefs"]) echo node_escapeshellcmd($CP_PATH)." ".node_escapeshellpath($from)." ".node_escapeshellpath($newname)." 2>&1<br>\n";
 exec(node_escapeshellcmd($CP_PATH)." ".node_escapeshellpath($from)." ".node_escapeshellpath($newname)." 2>&1",$tmp,$cpsig);
 touch($path.$name,$row["edate"]);
 }
 }
 if ($cpsig) {
 $fs_err = true;
 $writefilestat = LOGFAILED;
 }
 $outp = ($cpsig) ? " ".LOGFAILED."\n".$tmp[0]."\n" : "\n";


 $file_time += calctime ($pt1, microtime (), 5);
 $number_files--;

 if ((++$files_written % 100) == 0)
 {
 $file_eta = ($file_time / $files_written) * $number_files;
 $eta = $file_eta + $WRITEFS_LASTDUR[2];
 $eta = round ($eta);

 $sql = "UPDATE nodesetup SET intvalue = ".sqlf_tl_num($eta)." WHERE name = 'publish_eta'";
 query ($sql);
 } 

 if (!$FEATURE["skip_writefs_filelog"])
 log_publish($LOG_FP, $outp);
}

$WRITEFS_ACTDUR[1] = round ($file_time, 2);

$t3 = microtime();
$outp = "file write $writefilestat (".calctime($t2,$t3,3).")\n";
log_publish($LOG_FP, $outp);


if ($FEATURE["tag_image_resizer"]) {
 log_publish($LOG_FP, "starting image resizer...\n");
 
 $lines = file($IMG_RESIZER_PATH."?cmd=start");
 if (!$lines) {
 log_publish($LOG_FP, "could not start image resizer at $IMG_RESIZER_PATH\n");
 $outp = LOGFAILED."\n";
 $writepagestat = LOGFAILED;
 $fs_err = true;
 } else {
 log_publish($LOG_FP, "image resizer running");
 do {
 sleep(10);
 $lines = file($IMG_RESIZER_PATH."?cmd=status");
 if (!$lines) {
 $outp = LOGFAILED."\n";
 $writepagestat = LOGFAILED;
 $fs_err = true;
 }
 $status = trim($lines[0]);
 log_publish($LOG_FP, ".");
 } while ($status == "running" && !$fs_err);

 if ($status == "failed") {
 log_publish($LOG_FP, "\nimage resizer $status\n");
 $writepagestat = LOGFAILED;
 $fs_err = true;
 }

 if (!$fs_err) {
 log_publish($LOG_FP, "\nimage resizer $status\n");
 }
 }
}

$outp = "initiating directory switch...\n";
log_publish($LOG_FP, $outp);
$outp = "";

$eta = round ($WRITEFS_LASTDUR[2]);
$sql = "UPDATE nodesetup SET intvalue = '".sqlf_escaped($eta)."' WHERE name = 'publish_eta'";
query ($sql);

if (!$fs_err) {
 
 if (file_exists($red_nudepath."_old")) {
 $outp .= "rm -R $red_nudepath"."_old\n";
 if (node_plattform() == "win32") {
 if ($DEBUG["writefs"]) echo "node_delete(".$red_nudepath."_old)<br>\n";
 node_delete($red_nudepath."_old");
 } else {
 if ($DEBUG["writefs"]) echo node_escapeshellcmd($RM_PATH)." -R ".node_escapeshellpath($red_nudepath."_old")."<br>\n";
 $lastline = @system(node_escapeshellcmd($RM_PATH)." -R ".node_escapeshellpath($red_nudepath."_old"), $retvar);
 if( $retvar ) {
 $fs_err = true;
 $outp .= "Error while removing old pub directory. ($lastline)\n";
 }
 }
 } else {
 $outp .= "skipped rm -R $red_nudepath"."_old\n";
 }
 
 if (file_exists($red_nudepath)) {
 $outp .= "mv $red_nudepath ".$red_nudepath."_old\n";
 if (node_plattform() == "win32") {
 if ($DEBUG["writefs"]) echo "rename($red_nudepath, ".$red_nudepath."_old)<br>\n";
 rename($red_nudepath, $red_nudepath."_old");
 } else {
 if ($DEBUG["writefs"]) echo node_escapeshellcmd($MV_PATH)." ".node_escapeshellpath($red_nudepath)." ".node_escapeshellpath($red_nudepath."_old")."<br>\n";
 $lastline = @system(node_escapeshellcmd($MV_PATH)." ".node_escapeshellpath($red_nudepath)." ".node_escapeshellpath($red_nudepath."_old"), $retvar);
 if( $retvar ) {
 $fs_err = true;
 $outp .= "Error while moving current pub dir to old pub dir. ($lastline)\n";
 }
 }
 } else {
 $outp .= "skipped mv $red_nudepath ".$red_nudepath."_old\n";
 }
 
 if (file_exists($red_nudepath."_new")) {
 $outp .= "mv $red_nudepath"."_new $red_nudepath\n";
 if (node_plattform() == "win32") {
 if ($DEBUG["writefs"]) echo "rename(".$red_nudepath."_new, $red_nudepath)<br>\n";
 rename($red_nudepath."_new", $red_nudepath);
 } else {
 if ($DEBUG["writefs"]) echo node_escapeshellcmd($MV_PATH)." ".node_escapeshellpath($red_nudepath."_new")." ".node_escapeshellpath($red_nudepath)."<br>\n";
 $lastline = @system(node_escapeshellcmd($MV_PATH)." ".node_escapeshellpath($red_nudepath."_new")." ".node_escapeshellpath($red_nudepath), $retvar);
 if( $retvar ) {
 $fs_err = true;
 $outp .= "Error while moving new pub dir to current pub dir. ($lastline)\n";
 }
 }
 } else {
 $fs_err = true;
 $outp .= "skipped mv $red_nudepath"."_new $red_nudepath\n";
 }
} else {
 if (file_exists($red_nudepath."_fail")) {
 $outp .= "rm -R $red_nudepath"."_fail\n";
 if (node_plattform() == "win32") {
 if ($DEBUG["writefs"]) echo "node_delete(".$red_nudepath."_fail)<br>\n";
 node_delete($red_nudepath."_fail");
 } else {
 if ($DEBUG["writefs"]) echo node_escapeshellcmd($RM_PATH)." -R ".node_escapeshellpath($red_nudepath."_fail")."<br>\n";
 @system(node_escapeshellcmd($RM_PATH)." -R ".node_escapeshellpath($red_nudepath."_fail"));
 }
 } else {
 $outp .= "skipped rm -R $red_nudepath"."_fail\n";
 }
 if (file_exists($red_nudepath."_new")) {
 $outp .= "mv $red_nudepath"."_new $red_nudepath"."_fail\n";
 if (node_plattform() == "win32") {
 if ($DEBUG["writefs"]) echo "rename(".$red_nudepath."_new, ".$red_nudepath."_fail)<br>\n";
 rename($red_nudepath."_new", $red_nudepath."_fail");
 } else {
 if ($DEBUG["writefs"]) echo node_escapeshellcmd($MV_PATH)." ".node_escapeshellpath($red_nudepath."_new")." ".node_escapeshellpath($red_nudepath."_fail")."<br>\n";
 @system(node_escapeshellcmd($MV_PATH)." ".node_escapeshellpath($red_nudepath."_new")." ".node_escapeshellpath($red_nudepath."_fail"));
 }
 } else {
 $fs_err = true;
 $outp .= "skipped mv $red_nudepath"."_new $red_nudepath"."_fail\n";
 }
}
$t4 = microtime();

$WRITEFS_ACTDUR[2] = round (calctime ($t3, $t4, 5), 2);

$sql = "UPDATE nodesetup SET intvalue = 0 WHERE name = 'publish_eta'";
query ($sql);

$outp .= "directory switch ".LOGOK." (".calctime($t3,$t4,3).")\n";
log_publish($LOG_FP, $outp);


$dur = $WRITEFS_ACTDUR[0] . ";" . $WRITEFS_ACTDUR[1] . ";" . $WRITEFS_ACTDUR[2];
$sql = "UPDATE nodesetup SET textvalue = '".sqlf_escaped($dur)."' WHERE name = 'publish_writefs_lastdur'";
query ($sql);


chdir($NODEPATH);

$LOG["writefs"] = $outp;

if ($DEBUG["writefs"]) echo "--------------------------\n</pre>";

return !$fs_err;

}


?>
